﻿// <summary>ソースコード：モデル共通定義クラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

// ToDo namespace は　モデル開発者が変更して、ユニークな名称にして下さい
namespace jp.or.jccajsce.StorageFunctionRiver
{
    /// <summary><para>class outline:</para>
    /// <para>ＨＹＭＣＯモデル共通定義クラス</para>
    /// </summary>
    /// <remarks>
    /// <para>Remarks:</para>
    /// <para>本クラスは、必須ではないが、使用の便利さの為、常数等の定義を一つに纏めておく</para>
    /// <para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class StorageFunctionRiverDefine
    {
        // ToDo
        // 必要と思われる定義を設定して下さい。（自DLL内クラスで共通に使用すると思われる常数）
        //
        //********************************************************************
        //============================ 注意事項 ==============================
        //********************************************************************
        //
        // メンバ変数の定義を設定する場合、以下の２点を留意願います。
        //
        //  １．個別でメンバ変数を定義する場合は、メンバ変数の前後に対して、
        //      半角空白を区切り文字として挿入して下さい。
        //
        //  ２．ウィザードにて生成されたパターン識別子のメンバ変数に付随する
        //      番号(○○○_PTNnnn)は変更しないで下さい。
        //
        //        ○○○：ウィザード画面にて入力したパターン識別子
        //        _PTN  ：ウィザード自動生成付与文字
        //        nnn   ：ウィザード自動生成番号
        //
        //********************************************************************

        //********************************
        //===== ファクトリ関連定義 ========
        //********************************
        /// <summary>モデルファクトリ識別子</summary>
        public static HySID MODEL_FACTORY_LIB_ID = new HySID("jp.or.jccajsce.StorageFunctionRiver_Factory");

        //********************************
        //===== モデル関連定義 ========
        //********************************
        /// <summary>テスト用 モデル種別</summary>
        public static readonly HySObjectKind SFR_MODEL_KIND = new HySObjectKind("jp.or.jccajsce.StorageFunctionRiver_Model");
        /// <summary>テスト用 モデル名称</summary>
        public static readonly HySString SFR_MODEL_NAME = new HySString(Properties.Resources.STRING_MODEL_NAME);
        /// <summary>上流端流入量</summary>
        /// 1次元時系列
        public static readonly HySID INFLOW = new HySID("InFlow");
        /// ポイント時系列
        public static readonly HySID INFLOW_P = new HySID("InFlow_P");
        /// <summary>下流端流出量</summary>
        /// 1次元時系列
        public static readonly HySID OUTFLOW = new HySID("OutFlow");
        /// ポイント時系列
        public static readonly HySID OUTFLOW_P = new HySID("OutFlow_P");

        /// <summary>テスト用モデル種別</summary>
        public static readonly HySObjectKind StorageFunctionRiver_MODEL_KIND = new HySObjectKind("storagefunctionriverPrptyScrnFactory");
        //<@Add_> ウイザードによる追加の目印　目印を削除しないで下さい　削除した場合には、モデルの追加は、手動で行う必要があります。


    }
}
